From 22664ae52fde550d9ca786284823a4159f53b988 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 00:30:45 +0000
Subject: [PATCH 1260/2232] Fix missing declaration of impl<T> template


---

diff --git a/gen/src/builtin.rs b/gen/src/builtin.rs
index 7a4ddcd..f3240d0 100644
--- a/gen/src/builtin.rs
+++ b/gen/src/builtin.rs
@@ -24,6 +24,7 @@ pub struct Builtins<'a> {
     pub rust_slice_repr: bool,
     pub exception: bool,
     pub relocatable: bool,
+    pub friend_impl: bool,
     pub content: Content<'a>,
 }
 
@@ -51,6 +52,11 @@ pub(super) fn write(out: &mut OutFile) {
     if builtin.rust_str {
         include.cstdint = true;
         include.string = true;
+        builtin.friend_impl = true;
+    }
+
+    if builtin.rust_slice {
+        builtin.friend_impl = true;
     }
 
     if builtin.rust_box {
@@ -68,6 +74,7 @@ pub(super) fn write(out: &mut OutFile) {
 
     if builtin.rust_error {
         include.exception = true;
+        builtin.friend_impl = true;
     }
 
     if builtin.rust_isize {
@@ -89,7 +96,7 @@ pub(super) fn write(out: &mut OutFile) {
         writeln!(out, "struct unsafe_bitcopy_t;");
     }
 
-    if builtin.rust_error {
+    if builtin.friend_impl {
         out.begin_block(Block::AnonymousNamespace);
         writeln!(out, "template <typename T>");
         writeln!(out, "class impl;");

